
variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_TLS_CERTDIR: ""

docker-build:
  # Use the official docker image.
  image: docker:20.10.16
  stage: build
  tags:
    - arm64
  services:
    - name: docker:20.10.16-dind
      alias: docker
  before_script:
    - |
      attempts=300
      echo "---- Waiting $attempts sec for docker to come up ----"
      while ! docker info > /dev/null 2>&1; do
          echo "Connection attempts left: $attempts"
          if [ $attempts -eq 0 ]; then
              echo "Couldn't connect to docker, no attempts left"
              return 1
          fi;
          let attempts=$attempts-1
          echo "Connection to docker failed"
          sleep 1
      done
      echo "---- Docker came up ----"
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":$CI_COMMIT_REF_SLUG"
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = $tag"
      fi
      if [[ -n "$CI_COMMIT_TAG" ]]; then
        tag=":$CI_COMMIT_TAG"
        echo "Running on tag '$CI_COMMIT_TAG': tag = '$CI_COMMIT_TAG'"
      fi
    - docker build --pull -t "$CI_REGISTRY_IMAGE${tag}" .
    - docker push "$CI_REGISTRY_IMAGE${tag}"
  rules:
    - if: $CI_COMMIT_BRANCH == 'main'
    - if: $CI_COMMIT_TAG

